<template>
  <ApolloQuery
    query="@/graphql/qAllFilms.gql"
    class="container fluid fill-height grid-list-lg"
    @error="onMsg('error', $event)"
  >
    <template v-slot="{ result: { loading, data } }">
      <VLayout
        row
        align-center
        :class="loading ? 'wrap justify-center' : 'horiz-scroll'"
      >
        <VProgressCircular
          v-if="loading"
          :size="200"
          :width="9"
          color="#ffcc00"
          indeterminate
        />
        <template v-else-if="data">
          <VFlex
            v-for="(film, n) in data.allFilms"
            :key="n"
            xs12
          >
            <VHover>
              <template v-slot="{ hover }">
                <VImg
                  :src="require(`@/assets/films/capa-${n+1}.jpg`)"
                  width="320px"
                >
                  <VExpandTransition>
                    <div
                      v-if="hover"
                      class="reveal-hover d-flex display-3 white--text"
                    >
                      <VBtn
                        large
                        depressed
                        color="info"
                        @click="onSubmit(film.id, n+1)"
                      >
                        + informações
                      </VBtn>
                    </div>
                  </VExpandTransition>
                </VImg>
              </template>
            </VHover>
          </VFlex>
        </template>
      </VLayout>
    </template>
    <VDialog
      v-model="dialog"
      :max-width="1000"
    >
      <VCard
        v-if="dialog"
        dark
      >
        <VLayout
          row
          wrap
        >
          <VFlex
            xs12
            sm5
            md4
            :class="$vuetify.breakpoint.xsOnly && 'text-xs-center'"
          >
            <img
              :src="require(`@/assets/films/capa-${filmCapa}.jpg`)"
              style="width: 100%; max-width: 350px"
            >
          </VFlex>
          <VFlex
            xs12
            sm7
            md8
          >
            <VCardTitle primary-title>
              <div>
                <p class="display-1">
                  {{ filmSelect.title }}
                </p>
                <div class="title">
                  <p>Episode {{ filmSelect.episodeId }}</p>
                  <p>{{ new Date(filmSelect.releaseDate).getFullYear() }}</p>
                </div>
                <p>
                  <b>Director: </b>{{ filmSelect.director }}
                  <b>Producers: </b>{{ filmSelect.producers.join(', ') }}
                </p>
              </div>
              <VSpacer />
              <VBtn
                outline
                color="cyan"
                style="align-self: flex-start"
                @click="dialog = false"
              >
                Fechar
              </VBtn>
            </VCardTitle>
            <VCardText>
              {{ filmSelect.openingCrawl }}
            </VCardText>
          </VFlex>
        </VLayout>
      </VCard>
    </VDialog>
  </ApolloQuery>
</template>

<script lang="ts">
import { Mixins, Component } from 'vue-property-decorator';

// Mixins
import OnMsg from '@/mixins/onMsg';

// Query
import Films from '@/graphql/qFilms.gql';

@Component
export default class Home extends Mixins(OnMsg) {
  dialog = false

  filmCapa = 1

  filmSelect = {}

  async onSubmit(id: string, capa: number) {
    try {
      const { data } = await this.$apollo.query({
        query: Films,
        variables: {
          id,
        },
        fetchPolicy: 'network-only',
      });

      this.dialog = true;
      this.filmCapa = capa;
      this.filmSelect = data.Film;
    } catch (e) {
      this.onMsg('error', e);
    }
  }
}
</script>

<style lang="stylus">
  .horiz-scroll
    overflow-y hidden
    overflow-x auto
  .reveal-hover
    background-color rgba(black, .6)
    height 100%
    width 100%
    position absolute
    bottom 0
    align-items center
    justify-content center
</style>
